var _ = {
        config: {
                live: false,
                api: {
                        host: 'http://localhost/',
                        livehost: 'http://localhost/'
                },
                defaultController: 'home',
                cache: false,
                libpath: ''
        },
        hash: '',
        currentView: '',
        resizeFunc: null,
        views: [],
        jsfiles: new Array(),
        cssfiles: new Array(),
        ctrlfiles: new Array(),
        viewfiles: new Array(),
        errorNotFound: function () {},
        getJSON: function (url, callback, anim, cache) {
                if(typeof cache == 'string') {
                        var data = _.loadData(cache);
                        console.log(data);
                        if(data != null) {
                                console.log(data);
                                if(typeof callback == 'function')
                                        callback(data);
                                return false;
                        }
                }
                if(typeof anim == 'undefined')
                        _.ui.animWait();
                if(_.config.live) {
                        url = _.config.api.livehost + url;
                } else {
                        url = _.config.api.host + url;
                }
                if(url.indexOf('?') < 0) {
                        url = url + '?callback=?';
                } else {
                        url = url + '&callback=?';
                }
                $.ajax({
                        type: "GET",
                        dataType: "jsonp",
                        url: url,
                        timeout: 15000,
                        success: function (data) {
                                _.ui.animWait('stop');
                                if(typeof cache != 'undefined') {
                                        _.saveData(cache, data);
                                        _.loadData('hasil', cache);
                                }
                                if(typeof callback == 'function')
                                        callback(data);
                        },
                        error: function (x, t, m) {
                                if(t === "timeout") {
                                        $('.animWait').fadeOut();
                                        alertify.alert('connection timeout');
                                } else {
                                        $('.animWait').fadeOut();

                                        alertify.alert('connection error ');
                                }
                        }
                });
        },
        screen:function(){
                 var myWidth = 0, myHeight = 0;
                  if( typeof( window.innerWidth ) == 'number' ) {
                    //Non-IE
                    myWidth = window.innerWidth;
                    myHeight = window.innerHeight;
                  } else if( document.documentElement && ( document.documentElement.clientWidth || document.documentElement.clientHeight ) ) {
                    //IE 6+ in 'standards compliant mode'
                    myWidth = document.documentElement.clientWidth;
                    myHeight = document.documentElement.clientHeight;
                  } else if( document.body && ( document.body.clientWidth || document.body.clientHeight ) ) {
                    //IE 4 compatible
                    myWidth = document.body.clientWidth;
                    myHeight = document.body.clientHeight;
                  }
                return {'width':myWidth,'height':myHeight};
        },
        updateJSON: function (url, callback, index, limit) {
                if(typeof limit == 'undefined') {
                        limit = 15;
                }
                if(typeof index == 'undefined') {
                        index = 0;
                }
                index = index * limit;
                if(_.config.live) {
                        url = _.config.api.livehost + url;
                } else {
                        url = _.config.api.host + url;
                }
                if(url.indexOf('?') < 0) {
                        url = url + '?callback=?';
                } else {
                        url = url + '&callback=?';
                }
                url = url + '&start=' + index + '&limit=' + limit;
                $('<div class="loadNew"><center><img src="' + _.config.libpath + 'system/img/miniloader.gif" width="32px" height="auto"/></center></div>').appendTo($('.itemlist'));
                $.ajax({
                        type: "GET",
                        dataType: "jsonp",
                        url: url,
                        timeout: 15000,
                        success: function (data) {
                                //_.ui.animWait('stop');
                                $('.loadNew').remove();
                                callback(data);
                        },
                        error: function (x, t, m) {
                                if(t === "timeout") {
                                        //$('.animWait').fadeOut();
                                        $('.loadNew').remove();
                                        alertify.alert('connection timeout');
                                } else {
                                        //$('.animWait').fadeOut();
                                        $('.loadNew').remove();
                                        alertify.alert('connection error');
                                }
                        }
                });
        },
        router: function () {
                
                var result = new Array();
                var par = window.location.hash.replace('#!').split('/');
                if(typeof _.preload == 'function')
                        _.preload();
                if(par.length > 1) {
                        var x=0;
                        var y=par.length;
                        var locked=false;
                        for(x in par) {
                                if(par[x].indexOf('_') > 0) {
                                        var f = par[x].split('_');                                        
                                        if(!locked)
                                        y=x;
                                        locked=true;
                                        result = result + f[0] + '=' + f[1] + '&';
                                }
                        }                        
                        var p2='';
                        console.log(x);
                        for(var i=2;i<y;i++){
                            p2=p2+par[i]+'.';                        
                        }                   
                        p2=p2.substring(0,p2.length-1);
                        par[2]=p2;
                        if(par[2] == '') {
                                par[2] = 'index';
                        }
                        console.log(par[1] + '.' + par[2]);
                        if(typeof window[par[1]] == 'undefined') {
                                alertify.alert('Page not found');
                        }else
                        if(par[2].indexOf('fn.')<0)
                        {
                                if(typeof eval(par[1] + '.init') != 'function') {
                                        //alertify.alert('init function not defined');
                                }
                                if(typeof eval(par[1] + '.' + par[2]) == 'function') {
                                        //_.session('lastParam_'+par[2],result);
                                        if(window[par[1]+'_created']!=true)
                                        {
                                            if(typeof eval(par[1] + '.init') == 'function')
                                            {
                                                eval(par[1] + '.init')(function () {
                                                        window[par[1]+'_created']=true;
                                                        eval(par[1] + '.' + par[2])(result);
                                                });                        
                                            }else{
                                                    window[par[1]+'_created']=true;
                                                    eval(par[1] + '.' + par[2])(result);                                                
                                            }
                                        }else{
                                            eval(par[1] + '.' + par[2])(result);                                        
                                        }
                                }else {
                                console.log(typeof eval(par[1] + '.' + par[2]));
                                alertify.alert('Page not found');
                                } 
                        }else{
                                if(typeof eval(par[1] + '.' + par[2].replaceAll('fn.','')) == 'function') {
                                        eval(par[1] + '.' + par[2].replaceAll('fn.',''))(result);
                                }else {
                                console.log(typeof eval(par[1] + '.' + par[2]));
                                alertify.alert('Page not found');
                                }

                        }

                } else {
                        console.log(_.config.defaultController);
                        if(typeof window[_.config.defaultController]=='object')
                        {
                            eval(_.config.defaultController + '.index')();
                        }else{
                            alertify.error('index not found');
                        }
                }
        },
        log: function (msg) {
                alertify.log(msg);
        },
        alert: function (msg) {
                alertify.alert(msg);
        },

        event: function () {                
                $(".number").keydown(function (event) {
                        // Allow: backspace, delete, tab, escape, enter and .
                        if($.inArray(event.keyCode, [46, 8, 9, 27, 13, 190]) !== -1 ||
                                // Allow: Ctrl+A
                                (event.keyCode == 65 && event.ctrlKey === true) ||
                                // Allow: home, end, left, right
                                (event.keyCode >= 35 && event.keyCode <= 39)) {
                                // let it happen, don't do anything
                                return;
                        } else {
                                // Ensure that it is a number and stop the keypress
                                if(event.shiftKey || (event.keyCode < 48 || event.keyCode > 57) && (event.keyCode < 96 || event.keyCode > 105)) {
                                        event.preventDefault();
                                }
                        }
                });
                $('.scroll').scroll(function () {
                        if(typeof $(this).find('div.loadNew')[0] == 'undefined') {
                                if($(this).scrollTop() + $(this).innerHeight() == $(this)[0].scrollHeight) {
                                        if(typeof eval($(this).attr('touchbottom')) == 'function') {
                                                var lastPage = 0;
                                                if($(this).attr('lastPage') != null && typeof $(this).attr('lastPage') != 'undefined') {
                                                        lastPage = parseInt($(this).attr('lastPage'));
                                                } else {
                                                        $(this).attr('lastPage', '1');
                                                        lastPage = 1;
                                                }
                                                eval($(this).attr('touchbottom'))(lastPage);
                                        }
                                }
                        }
                });
                $('form').on("submit", function () {
                        return false;
                });
                $('input[type=submit]').click(function () {
                        var form = findParent($(this), 'form');
                        var con = form.parent();
                        _.form.submit(form);
                        return false;
                });
        },
        form: {
                getParam: function (el) {
                        var str = '';
                        el.find('.var').each(function () {
                                var val = '';
                                if(typeof $(this).attr('data-val') != 'undefined') {
                                        val = $(this).attr('data-val');
                                } else {
                                        val = $(this).val();
                                }
                                if(str.length > 0) {
                                        if(val != '')
                                                str = str + '&';
                                }
                                if($(this).attr('type') == 'password') {
                                        val = CryptoJS.MD5(val);
                                }
                                if(val != '')
                                        str = str + $(this).attr('id') + '=' + val;
                        });
                        return str;
                },
                validation: function (el) {
                        $('.errorRequired').remove();
                        var ret = true;
                        $(el).find('.validemail').each(function () {
                                $(this).removeClass('error');
                                if($(this).val().indexOf('@') > 2 && $(this).val().indexOf('.') > 4) {
                                        ret = true;
                                } else {
                                        ret = false;
                                        var th = $(this);
                                        th.addClass('error');
                                }
                        });
                        $(el).find('.required').each(function () {
                                $(this).removeClass('error');
                                var th = $(this);
                                console.log(typeof $(this).val());
                                if(typeof $(this).attr('id') != 'undefined')
                                        if($(this).val() == '') {
                                                th.addClass('error');
                                                ret = false;
                                        }
                        });
                        return ret;
                },
                submit: function (el) {
                        if(_.form.validation(el)) {
                                _.saveData('post', '');
                                if(el.attr('stay')==null)
                                el.fadeOut('slow');
                                var method = el.attr('method');
                                var target = el.attr('target');
                                if(typeof method == 'undefined') {
                                        method = 'get';
                                }
                                var param = _.form.getParam(el);
                                if(method == 'get') {
                                        _.session('get', param);
                                        if(target == '_blank') {
                                                window.location = '#!/' + el.attr('action') + '/' + param.replaceAll('&', '/').replaceAll('=', '_');
                                        } else {

                                                eval(el.attr('action').replaceAll('/', '.'))(param);
                                        }
                                } else {
                                        _.session('post', param);
                                        if(target == '_blank') {
                                                window.location = '#!/' + el.attr('action') + '/' + param.replaceAll('&', '/').replaceAll('=', '_');
                                        } else {
                                            console.log(el.attr('action').replaceAll('/', '.'));
                                                eval(el.attr('action').replaceAll('/', '.'))(param);
                                        }
                                }
                        }
                }
        },
        template: function (html, data) {
                var source = html;
                var template = Handlebars.compile(source);
                return template(data);
        },
        ui: {
                loadstr:'Wait..',
                animWait: function (mode, func) {
                        if(typeof mode == 'string') {
                                if(mode == "stop") {
                                        $('.animWait').fadeOut(500, function () {
                                                $(this).remove();
                                                if(typeof func == 'function')
                                                        func();
                                        });
                                }else{
                                    loadstr=mode;
                                }
                        } else {
                                $('.content').append('<div class="animWait">'+_.ui.loadstr+'</div>');
                                $('.animWait').css('margin-left',$('.animWait').width()/2*-1);
                                $('.animWait').fadeIn('slow', function () {});
                        }
                },

        },
        progress: null,
        pnum: 0,
        totalView: 0,
        loadData: function (name) {
                return $.totalStorage(name);
        },
        saveData: function (name, val) {
                return $.totalStorage(name, val);
        },
        deleteData: function (name) {
                return $.totalStorage(name, null);
        },
        session: function (key, val) {
                if(typeof val == 'undefined') {
                        if(_.loadData(key) != null) {
                                var value = _.loadData(key);
                                if(key == 'post') {
                                        _.deleteData(key);
                                }
                                return $.base64.decode(value);
                        } else {
                                return false;
                        }
                } else {
                        _.saveData(key, $.base64.encode(val));
                }
        },
        getView: function (name, whendone, path) {
                var xpath = '';
                if(typeof path != 'undefined') {
                        xpath = path;
                }
                if((_.config.cache) && (typeof $.totalStorage(name) != 'undefined')) {
                        _.pnum += 1;
                        if(_.totalView == _.pnum) {
                                whendone();
                                return true;
                        }
                } else {
                        $.get(xpath + 'view/' + name + '.html', function (data) {
                                $.totalStorage(name.replace(/^.*(\\|\/|\:)/, ''), data);
                                _.pnum += 1;
                                if(_.totalView == _.pnum) {
                                        whendone();
                                        return true;
                                }
                        });
                }
        },
        loadSystemViews: function (names, whendone) {
                _.totalView = names.length;
                pnumx = 0;
                _.pnum = 0;

                function checkDonex() {
                        pnumx++;
                        if(pnumx == 2) {
                                for(var o in names) {
                                        eval(names[o] + '.view=new View("' + names[o] + '");');
                                }
                                if(typeof whendone == 'function')
                                        whendone();
                        }
                }
                for(var i in names) {
                        this.getView(names[i], checkDonex, _.config.libpath + 'system/');
                }
                _.loadControlers(names, checkDonex, _.config.libpath + 'system/');
        },
        loadViews: function (names, whendone) {
                _.totalView = names.length;
                _.views = names;
                _.pnum = 0;
                if(names.length<=0)
                    whendone();
                for(var i in names) {
                        this.getView(names[i], function () {                                                            
                                for(var o in names) {
                                        if(typeof window[names[o].replace(/^.*(\\|\/|\:)/, '')] != 'object') {
                                                window[names[o].replace(/^.*(\\|\/|\:)/, '')] = {};
                                        }    
                                        eval(names[o].replace(/^.*(\\|\/|\:)/, '') + '.view=new View("' + names[o].replace(/^.*(\\|\/|\:)/, '') + '");');                                                                                
                                }

                                if(typeof whendone == 'function')
                                        whendone();

                        });
                }
        },
        loadModels: function (models, whendone) {
                this.loadJs(models, 'model', '.js', whendone);
        },
        loadControlers: function (controlers, whendone, path) {
                var xpath = '';
                if(typeof path != 'undefined') {
                        xpath = path;
                }
                if(controlers.length>0)
                {
                    this.loadJs(controlers, xpath + 'controller', '.js', whendone);
                }else{
                    whendone();
                }
        },
        loadJs: function (js, path, ext, whendone, required) {
                var systemfiles = false;
                var newpath = '';
                if(typeof required == 'undefined') {
                        required = false;
                };
                var total = js.length;
                var progress = 0;
                var ds = '';
                if(path != '') {
                        ds = '/';
                } else {
                        ds = '';
                }
                for(var i in js) {
                        if(js[i].indexOf('system/') > -1) {
                                systemfiles = true;
                        } else {
                                systemfiles = false;
                        }
                        if(systemfiles) {
                                newpath = _.config.libpath + path;
                        } else {
                                newpath = path;
                        }
                        loader.injectJs(newpath + ds + js[i] + ext, function () {
                                progress += 1;
                                if(required) {
                                        if(typeof _.progress == 'function') _.progress((progress / total) * 100);
                                }
                                if(progress == total) {
                                        if(typeof whendone == 'function')
                                                whendone();

                                        return true;
                                }
                        });
                }

        },
        loadCss: function (css, path, ext, whendone) {
                var systemfiles = false;
                var newpath = '';
                var total = css.length;
                var progress = 0;
                var ds = '';
                if(path != '') {
                        ds = '/';
                } else {
                        ds = '';
                }
                for(var i in css) {
                        if(css[i].indexOf('system/') > -1) {
                                systemfiles = true;
                        } else {
                                systemfiles = false;
                        }
                        if(systemfiles) {
                                newpath = _.config.libpath + path;
                        } else {
                                newpath = path;
                        }
                        loader.injectCss(newpath + ds + css[i] + ext, function () {
                                progress += 1;
                                if(progress == total) {
                                        whendone();
                                        return true;
                                }
                        });
                }
        },
        addJs: function (js) {
                if(typeof js == 'object') {
                        for(var i in js) {
                                this.jsfiles.push(js[i]);
                        }
                } else {
                        this.jsfiles.push(js);
                }
        },
        addController: function (js, setDefault) {
                if(typeof js == 'object') {
                        for(var i in js) {
                                this.ctrlfiles.push(js[i]);
                        }
                } else {
                        this.ctrlfiles.push(js);
                        if(typeof setDefault != 'undefined') {
                                if(setDefault) {
                                        _.config.defaultController = js;
                                }
                        }
                }
        },
        addCss: function (css) {
                if(typeof css == 'object') {
                        for(var i in css) {
                                this.cssfiles.push(css[i]);
                        }
                } else {
                        this.cssfiles.push(css);
                }
        },
        addView: function (view) {
                if(typeof view == 'object') {
                        for(var i in view) {
                                this.viewfiles.push(view[i]);
                        }
                } else {
                        this.viewfiles.push(view);
                }
        },
        require: function (js, css, whendone) {
                var xjs = [
                        'system/js/jgestures.min.js',
                        'system/js/handlebars.js',                        
                        'system/js/jquery.base64.js',
                        'system/js/md5.js',
                        'system/js/alertify.min.js'
                ];
                var xcss = [
                        'system/css/alertify.core.css',
                        'system/css/alertify.default.css'
                ];
                for(var i in js) {
                        xjs.push(js[i]);
                }
                for(var i in css) {
                        xcss.push(css[i]);
                }
                this.loadCss(xcss, '', '', function () {
                        _.loadJs(xjs, '', '', function () {
                                whendone();
                                return true;
                        }, true);
                });
        },
        resize: function (func) {
                if(typeof func == 'function')
                        _.resizeFunc = func;
        },
        activeController: function () {
                var par = window.location.hash.replace('#!').split('/');
                if(typeof par[1] != 'undefined') {
                        return window[par[1]];
                } else {
                        return window[_.config.defaultController];
                }
        },
        bindWindowEvent: function () {
                $(window).on('hashchange', function () {
                        if(_.hash != window.location.hash) {
                                console.log(_.hash);
                                _.router();
                                _.hash = window.location.hash;
                        }
                });
                $(window).resize(function () {
                        if(typeof _.resizeFunc == 'function') {
                                _.resizeFunc();
                        }
                        var par = window.location.hash.replace('#!').split('/');
                        if(typeof _.activeController().resize == 'function')
                                _.activeController().resize();
                        $('.btnLabel').each(function () {
                                var w = $(this).parent().width();
                                var fs = (14 / 100) * w;
                                if(fs > 13) {
                                        fs = 13;
                                }
                                $(this).css('font-size', fs + 'px');
                        });
                });
        },
        redirect: function (url) {
                window.location = '#!/' + url;
        },
        deviceReady: function (whendone) {
                if($(document).width() > 800) {
                        $(document).ready(whendone);
                } else {
                        //document.addEventListener('deviceready',whendone,false);
                        whendone();
                }
        },
        run: function (whendone) {
                var th = this;                
                this.loadSystemViews(['startup','home'], function () {
                        startup.init();
                        th.deviceReady(function () {
                                th.require(th.jsfiles, th.cssfiles, function () {
                                        th.loadControlers(th.ctrlfiles, function () {                                            
                                                th.loadViews(th.viewfiles, function () {                                                    
                                                        $('#progress').fadeOut(function () {

                                                                if(typeof _.resizeFunc == 'function') {
                                                                        _.resizeFunc();
                                                                }

                                                                if(typeof whendone == 'function')
                                                                        whendone();
                                                                th.router();
                                                                th.bindWindowEvent();
                                                        });
                                                });
                                        })
                                });
                        });
                });
        }
}
var keyStr = "ABCDEFGHIJKLMNOP" +
        "QRSTUVWXYZabcdef" +
        "ghijklmnopqrstuv" +
        "wxyz0123456789+/" +
        "=";
String.prototype.encode64 = function () {
        var input = escape(this);
        var output = "";
        var chr1, chr2, chr3 = "";
        var enc1, enc2, enc3, enc4 = "";
        var i = 0;
        do {
                chr1 = input.charCodeAt(i++);
                chr2 = input.charCodeAt(i++);
                chr3 = input.charCodeAt(i++);
                enc1 = chr1 >> 2;
                enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
                enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
                enc4 = chr3 & 63;
                if(isNaN(chr2)) {
                        enc3 = enc4 = 64;
                } else if(isNaN(chr3)) {
                        enc4 = 64;
                }
                output = output +
                        keyStr.charAt(enc1) +
                        keyStr.charAt(enc2) +
                        keyStr.charAt(enc3) +
                        keyStr.charAt(enc4);
                chr1 = chr2 = chr3 = "";
                enc1 = enc2 = enc3 = enc4 = "";
        } while (i < input.length);
        return output;
}
String.prototype.toObject = function () {
        var x = this.split('&');
        var r = {};
        for(var i in x) {
                var f = x[i].split('=');
                r[f[0]] = f[1];
        }
        return r;
}
String.prototype.decode64 = function () {
        var input = this;
        var output = "";
        var chr1, chr2, chr3 = "";
        var enc1, enc2, enc3, enc4 = "";
        var i = 0;
        // remove all characters that are not A-Z, a-z, 0-9, +, /, or =
        var base64test = /[^A-Za-z0-9\+\/\=]/g;
        if(base64test.exec(input)) {
                alertify.error("There were invalid base64 characters in the input text.\n" +
                        "Valid base64 characters are A-Z, a-z, 0-9, '+', '/',and '='\n" +
                        "Expect errors in decoding.");
        }
        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
        do {
                enc1 = keyStr.indexOf(input.charAt(i++));
                enc2 = keyStr.indexOf(input.charAt(i++));
                enc3 = keyStr.indexOf(input.charAt(i++));
                enc4 = keyStr.indexOf(input.charAt(i++));
                chr1 = (enc1 << 2) | (enc2 >> 4);
                chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
                chr3 = ((enc3 & 3) << 6) | enc4;
                output = output + String.fromCharCode(chr1);
                if(enc3 != 64) {
                        output = output + String.fromCharCode(chr2);
                }
                if(enc4 != 64) {
                        output = output + String.fromCharCode(chr3);
                }
                chr1 = chr2 = chr3 = "";
                enc1 = enc2 = enc3 = enc4 = "";
        } while (i < input.length);
        return unescape(output);
}
Number.prototype.formatMoney = function (c, d, t) {
        var n = this,
                c = isNaN(c = Math.abs(c)) ? 2 : c,
                d = d == undefined ? "." : d,
                t = t == undefined ? "," : t,
                s = n < 0 ? "-" : "",
                i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + "",
                j = (j = i.length) > 3 ? j % 3 : 0;
        return s + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : "");
};
String.prototype.replaceAll = function (old, newstr) {
        var regex = new RegExp(old, 'g');
        return this.replace(regex, newstr);
}
String.prototype.toURL = function () {
        return this.replaceAll('&', '/').replaceAll('=', '_');
}

function View(name) {
        this.render = function (data) {
                var ele = '.content';
                var html = _.loadData(name);
                if(typeof data == 'object') {
                        var template = Handlebars.compile(html);
                        html = template(data);
                }
                $(ele).html(html);
                _.event();
                if(typeof _.activeController().resize == 'function') {
                        _.activeController().resize();
                }
        };
        this.renderTo = function (ele, data) {
                if($(ele).length > 0) {
                        var html = _.loadData(name);
                        if(typeof data == 'object') {
                                var template = Handlebars.compile(html);
                                html = template(data);
                        }
                        $(ele).html(html);
                        var par = window.location.hash.replace('#!').split('/');
                        _.event();
                } else {
                        _.redirect(_.config.defaultController + '/index');
                }
        },
        this.toHTML = function (data) {
                var html = _.loadData(name);
                if(typeof data == 'object') {
                        var template = Handlebars.compile(html);
                        html = template(data);
                }
                return html;
        }
}

function findParent(a, b) {
        var parent = false;
        a.addClass('dummy');
        $(b).each(function () {
                console.log($(this).find('.dummy').length);
                if($(this).find('.dummy').length > 0) {
                        a.removeClass('dummy');
                        parent = $(this);
                }
        });
        return parent;
}

function goto(fn) {
        if(typeof fn != 'undefined') {
                if(typeof fn == 'function') {
                        fn();
                }
        }
}

function IsNumeric(input) {
        var RE = /^-{0,1}\d*\.{0,1}\d+$/;
        return(RE.test(input));
}